///////////////////////////////////////////////////////////////////////////////
// Command line interface between Wii Homebrew Launcher and libogc >= 1.4.7  //
// by Hell Hibou (2008)                                                      //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <wiiuse/wpad.h>

#define gotoXY(x,y) printf("\x1b[%i;%iH", y, x)

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

int SplitDrivePath (const char * FullPath, char * * Drive, char * * Path)
{
	int Boucle = 0;
	char * PtrTemp;
	
	if (FullPath == NULL) { return -1; }
	PtrTemp = malloc (strlen(FullPath) + 1);
	strcpy  (PtrTemp, FullPath);

	while (PtrTemp[Boucle] != 0)
	{
		if (PtrTemp[Boucle] == '/')
		{
			PtrTemp[Boucle] = 0x00;
			*Drive = PtrTemp;
			*Path  = PtrTemp + Boucle + 1;
			return 1;
		}
		
		Boucle++;
	}
	
	*Drive = PtrTemp + strlen(FullPath);
	*Path  = PtrTemp;
	
	return 0;
}

int main(int argc, char **argv) 
{
	int Boucle;
	char * Drivename, * Path;

	VIDEO_Init();
	WPAD_Init();
	rmode =  VIDEO_GetPreferredMode(NULL);
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,0,0,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	gotoXY (0,1);
	
	
	
	printf ("  argc = %i\n", argc);
	for (Boucle=0; Boucle < argc; Boucle++)
	{
		printf ("\n  argv[%i] = %s\n", Boucle, argv[Boucle]);
		SplitDrivePath (argv[Boucle], &Drivename, &Path);
		
		if ((Path[0] != 0x00) && (Drivename[0] != 0x00))
		{
			printf ("            Path  = %s\n", Path);
			printf ("            Drive = %s\n",  Drivename);
			
			if (strcmp (Drivename, /*"frontsd:"*/ "fat3:") == 0)
			{ printf ("                    Device is Front SD\n"); }
			else if (strcmp (Drivename, /*"sdgeckoa:"*/ "fat1:") == 0)
			{ printf ("                    Device is SD Gecko in slot A\n"); }
			else if (strcmp (Drivename, /*"sdgeckob:"*/ "fat2:") == 0)
			{ printf ("                    Device is SD Gecko in slot B\n"); }
			else if (strcmp (Drivename, "dvd:") == 0)
			{ printf ("                    Device is DVD\n"); }
			else if (strcmp (Drivename, /*"usb:"*/ "fat4:") == 0)
			{ printf ("                    Device is USB-flash in slot B\n"); }
			else if (strncmpi (Drivename, "smb:", 4) == 0)
			{
				char * Server;
				char * User;
				char * Password;
				char * Share;
				
				printf ("                    Device is shamba share\n"); 
				Server = strstr (Drivename, ":");
				if (Server == NULL) { continue; }
				Server[0] = 0x00;
				Server++;
				
				User = strstr (Server, ":");
				if (User == NULL) { continue; }
				User[0] = 0x00;
				User++;
				
				Password = strstr (User, ":");
				if (Password == NULL) { continue; }
				Password[0] = 0x00;
				Password++;	
				
				Share = strstr (Password, ":");
				if (Share == NULL) { continue; }
				Share[0] = 0x00;
				Share++;
				
				printf ("                    Server: %s\n", Server);
				printf ("                    User: %s\n", User);			
				printf ("                    Password: %s\n", Password);
				printf ("                    Share: %s\n", Share);	
			}
			else if (strncmpi (Drivename, "wiiload:", 8) == 0)
			{
				char * Server;
				char * Port;
				
				printf ("                    Device is Wiiload\n"); 
				
				Server = strstr (Drivename, ":");
				if (printf == NULL) { continue; }
				Server[0] = 0x00;
				Server++;
				
				Port = strstr (Server, ":");
				if (printf == NULL) { continue; }
				Port[0] = 0x00;
				Port++;
				
				printf ("                    Send by %s on port %s.\n", Server, Port);
			}
			else
			{ printf ("                    Device is unknow\n"); }
		}
	}
	
	while(1)
	{	
		WPAD_ScanPads();
		if(WPAD_ButtonsDown(0) & WPAD_BUTTON_HOME) 
		{
			void (*reload)() = (void(*)())0x80001800;
			reload();
		}
		VIDEO_WaitVSync();
	}
	
	return 0;
}
